###############################################################################
#
# <p>KOSHIAN  Amazon Web Service Ƹ</p>
# <pre>
#   {{koshiamazon b,5,2}}
# </pre>
# <p>
#   genre
#    a:Blended
#    b:Books
#    c:Classical
#    d:DVD
#    e:Electronics
#    f:ForeignBooks
#    h:Hobbies
#    k:Kitchen
#    l:HealthPersonalCare
#    m:Music
#    p:SportingGoods
#    s:Software
#    t:Toys
#    v:VideoGames
#   number
#    default:1
#    max:10
#   words
#    default:1
# </p>
#
###############################################################################
package plugin::koshiamazon::Koshiamazon;
use LWP::UserAgent;
use XML::Simple;
use HTTP::Request::Common qw(POST);
use Unicode::RecursiveDowngrade;
use Encode qw/from_to/;

#==============================================================================
# 󥹥ȥ饯
#==============================================================================
sub new {
  my $class = shift;
  my $self = {};
  return bless $self,$class;
}
#==============================================================================
# ѥ饰ե᥽å
#==============================================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $opt = shift;
  my $num = shift;
  my $words = shift;
  
  my %genre = (
    "a" => 'Blended',
    "b" => 'Books',
    "c" => 'Classical',
    "d" => 'DVD',
    "e" => 'Electronics',
    "f" => 'ForeignBooks',
    "h" => 'Hobbies',
    "k" => 'Kitchen',
    "l" => 'HealthPersonalCare',
    "m" => 'Music',
    "p" => 'SportingGoods',
    "s" => 'Software',
    "t" => 'Toys',
    "v" => 'VideoGames',
  );

  if(($opt eq "") || !(exists($genre{$opt}))){
    $opt = "a";
  }
  $opt = $genre{$opt};

  if($num eq "") {
    $num = 1;
  }
  if($words eq ""){
    $words = 1;
  }

  my $AccessKeyId = 'XXXXXXXXXXXXXXXXXXXX';
  my $UserAgent = 'ECSReader/0.1';
  my $ResponseGroup = 'Small,Images';
  my $AssociateTag = "";

  my $xml;
  my $cgi = $wiki->get_CGI;
  my $pagename = $cgi->param("page");
  my $word = &koshian($wiki,$pagename,$words);

  my $buf = "<div class=\"koshiamazon\">$word <small>extracted by ";
  $buf .= "<a href=\"http://blog.zuzara.com/2006/12/10/171/\">koshian</a></small><table>";  

  $word =~ s/([^A-Za-z0-9])/sprintf("%%%02X",ord($1))/seg;

  my $request_url = 'http://webservices.amazon.co.jp/onca/xml';
  $request_url .= '?Service=AWSECommerceService&AWSAccessKeyId='.$AccessKeyId;
  $request_url .= '&Operation=ItemSearch';
  $request_url .= '&ResponseGroup='.$ResponseGroup;
  $request_url .= '&SearchIndex='.$opt;
  $request_url .= '&Keywords='.$word;
  if($AssociateTag){
    $request_url .= '&AssociateTag='.$AssociateTag;
  }

  my $ua = LWP::UserAgent->new;
  $ua->timeout(10);
  $ua->agent($UserAgent);
  my $res = $ua->get($request_url);
  if($res->is_success){
    my $rd = Unicode::RecursiveDowngrade->new;
    $xml = $rd->downgrade(XMLin($res->content,ForceArray => 1));
  }

  my $items = $xml->{Items}->[0]{Item};
  if($items){
    $count = 1;
    for my $item (@{$items}){
      my $image_url = $item->{ImageSets}->[0]{ImageSet}->[0]{SmallImage}->[0]{URL}->[0];
      my $title = $item->{ItemAttributes}->[0]{Title}->[0];
      my $detail = $item->{DetailPageURL}->[0];
      my $manufacturer = $item->{ItemAttributes}->[0]{Manufacturer}->[0];
      my $author = $item->{ItemAttributes}->[0]{Author}->[0];
      my $artist = $item->{ItemAttributes}->[0]{Artist}->[0];

      $buf .= "<tr><td rowspan=\"5\">";
      if($image_url){
#        $buf .= "<img src=\"$image_url\">";
        $buf .= "<a href=\"$detail\"><img src=\"$image_url\"></a>";
      }
      $buf .= "</td></tr><tr><td><a href=\"$detail\">$title</a></td></tr>";
      $buf .= "<tr><td>$manufacturer</td></tr>";
      $buf .= "<tr><td>$author</td></tr>";
      $buf .= "<tr><td>$artist</td></tr>";
      if($count >= $num){
        last;
      }
      $count++;
    }
    $buf .= "</table></div>";
  }else{
    $buf .= "</table></div>";
#    return Util::paragraph_error('뾦ʤޤ');
  }

  from_to($buf,"utf8","euc-jp");  

  return $buf;
}

sub koshian {
  my $wiki = shift;
  my $pagename = shift;
  my $keywords = shift;

  my $content = $wiki->get_page($pagename);
  $pagename = &Util::url_encode($pagename);

  my @words;

  my $cachefile = $wiki->config('log_dir')."/$pagename.koshian";
  if((-e $cachefile) && !(&newerfile($cachefile, $wiki->config('data_dir')."/$pagename.wiki"))){
    return Util::load_config_text(undef,$cachefile);
  }

  from_to($content,"euc-jp","utf8");

  my $request_url = 'http://zuzara.dyndns.org/api/koshian';
  my $req = POST $request_url, [ q => $content];

  my $ua = LWP::UserAgent->new;
  $ua->timeout(10);
  $ua->agent('ECSReader/0.1');
  my $res = $ua->request($req);
  if($res->is_success){
    my $content = $res->content;
    $content =~ s/<[\/]*ResultSet>//g;
    $content =~ s/<Result.*?>//g;
    $content =~ s/(WWW|HTTP|HTML|HTM)//g;
    @words = split(/<\/Result>/,$content);
  }

  my %count = ();
  if(@words){
    for my $word (@words){
      $count{$word}++ if($word);
    }
  }else{
    return Util::paragraph_error('No Keyword.');
  }

  my $c = 1;
  my $buf = "";
  for my $word (sort {$count{$b} <=> $count{$a}} keys %count){
    $buf .= $word." ";
    if($c >= $keywords){
      last;
    }
    $c++;
  }

  &Util::save_config_text(undef,$cachefile,$buf);
  
  return $buf;
}

#==============================================================================
# ե꿷ե뤬ǥ쥯ȥˤ뤫ǧ
#     1:ե뤬Ĥä
#     0:                Ĥʤä
#    -1:顼
#==============================================================================
sub newerfile {
    my $criterion = shift;	# ˤʤե
    my $file = shift;	# Ӥե

  if ((stat($criterion))[9] < (stat($file))[9]){
    return 1;
  }else{
    return 0;
  }
}

1;
